{% extends "front/base_logged.html" %}
{% load static %}
{% load i18n %}

{% block content %}

    <div class="jumbotron">
        <div class="row">
            <div class="col-xs-5">
                <h1>
                    {% trans "Sistemas de Previsão" %}
                </h1>
            </div>
            <div class="col-xs-7 text-right">
                <button id="btn_extdep" type="button" class="btn btn-default" data-toggle="tooltip" data-placement="bottom" title="{% trans 'Ver pedidos de extensão de sistemas' %}">
                    <span class="glyphicon glyphicon-calendar"></span> <strong>{% trans "Pedidos de Extensão" %}</strong>
                </button>
                <button id="btn_new" type="button" class="btn btn-primary" data-toggle="tooltip" data-placement="bottom" title="{% trans 'Abrir novo Assistente de Configuração' %}">
                    <span class="glyphicon glyphicon-plus-sign"></span> <strong>{% trans "Novo Sistema" %}</strong>
                </button>
            </div>
        </div>
    </div>

    <div class="panel panel-default">
      <div class="panel-heading">
          <strong>{% trans "Gestão de Sistemas" %}</strong>
          <div class="help">
              <button id="help_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Mais info' %}" data-title="{% trans 'Mais info' %}" data-title_alt="{% trans 'Menos info' %}">
                  <span class="glyphicon glyphicon-question-sign"></span>
              </button>
          </div>
      </div>
      <div id="help" class="alert alert-warning cst_hide">
          {% include "front/deployments_text.html" %}
      </div>
      <div class="panel-body">
          <table id="deploy_table" class="table table-responsive table-hover"></table>
      </div>
    </div>

    {% include app|add:"/modal/deploy.html" %}
    {% include "front/modal/extenddeploy.html" %}
    {% include "front/modal/extenddeploytable.html" %}
    {% include "front/modal/processing.html" %}

    {% if rate %}
    {% include "front/modal/rate_service.html" %}
    {% endif %}

    <!-- JQuery UI - IMPORTANT - custom build without tooltip widget (conflict with Bootstrap) -->
    <link rel="stylesheet" href="{% static 'vendor/jquery/jquery-ui-1.12.1.min.css' %}">
    <script src="{% static 'vendor/jquery/jquery-ui-1.12.1.min.js' %}"></script>
    <script type="text/javascript">
        // Global variables
        var link = null;
        var deploy_table = null;

        // New Deployment action
        $('#btn_new').click(function(e){
            if (last_step > 0) {
                link = '/deployments/new/';
                $('#cfm_tit').html(setmessage('new')[0]);
                $('#cfm_str').html(setmessage('new')[1]);     // Set message according to action
                $('#divModal_confirm').modal('show');            // Show Confirm Modal
            } else {
                // Validate server-side if user can create new deploy
                //newdeploy("{% url 'front:new_deploy' %}", "/{{ app }}/step1/restart/");
                window.location.href = "{% url 'wizard:step1_restart' %}";
            }
            e.preventDefault();
        });

        // View Extend Deploy requests action
        $('#btn_extdep').click(function(e){
            // Add some animation
            var btn = $(this);
            var btnlbl = btn.html();
            btn.html('<span class="glyphicon glyphicon-repeat spin"></span> ' + btnlbl);

            // Disable button to prevent multiple calls
            btn.attr('disabled', '');

            // Load Extend Deploy requests into modal
            $('#extenddeploy_table').load('{% url 'front:view_extend_deploys' %}', function() {
                // Show modal
                $('#divModal_extenddeploy').modal('show');
            });

            // Reset button
            btn.html(btnlbl);
            btn.removeAttr('disabled');
        });

        // Function to set confirmation message string
        function setmessage(action) {
            var tit = 'Atenção';
            var message = '';
            switch(action) {
                case 'new':
                    tit = '{% trans "Novo Sistema" %}';
                    message = '{% trans "O Assistente de Configuração já tem um Sistema carregado. Se fez alterações ao sistema e deseja mantê-las prima Não e no Assistente guarde-o primeiro." %}';
                    break;
                case 'open':
                    tit = '{% trans "Abrir Sistema" %}';
                    message = '{% trans "O Assistente de Configuração já tem um Sistema carregado. Se fez alterações ao sistema e deseja mantê-las prima Não e no Assistente guarde-o primeiro." %}';
                    break;
                case 'clone':
                    tit = '{% trans "Clonar Sistema" %}';
                    message = '{% trans "Será criado um novo Sistema com base na configuração do Sistema selecionado." %}';
                    break;
                case 'deactivate':
                    tit = '{% trans "Desativar Sistema" %}';
                    message = '{% trans "Esta ação pára o Sistema e o mesmo deixará de produzir resultados." %}';
                    break;
                case 'reactivate':
                    tit = '{% trans "Reativar Sistema" %}';
                    message = '{% trans "Esta ação ativa o Sistema e o mesmo voltará a produzir resultados." %}';
                    break;
                case 'delete':
                    tit = '{% trans "Apagar Sistema" %}';
                    message = '{% trans "Ao apagar o Sistema não poderá recuperá-lo." %}';
                    break;
                default:
                    break;
            }
            return [tit, message];
        }

        // Format date function according to lang
        function formatDate(val) {
            var lang = $('html').attr('lang');
            var d = val.split('/');
            return new Date(d[2], d[1] - 1, d[0]);

            // Changed to en-gb that is equal to pt format
            //if (lang=='pt') {
            //    return new Date(d[2], d[1] - 1, d[0]);
            //} else {
            //    return new Date(d);
            //}
        }

        // Set all actions to buttons inside table rows
        function setactions() {
            // Configure action buttons
            $('button[data-action]').each(function(i, obj){
                $(obj).click(function(e){
                    var rowdata = deploy_table.row($(obj).parents('tr')).data();

                    // Get action
                    var action = $(obj).attr('data-action');
                    var deploy_id = $(obj).attr('data-id');
                    link = '/deployments/' + action + '/' + deploy_id + '/';

                    // no need to ask for confirmation - just execute
                    if (action == 'print') {
                        window.open(link, '_blank');
                        return;
                    }

                    // no need to ask for confirmation - just execute
                    if (action == 'open' && last_step == 0) {
                        $('#divModal_processing').modal('show');
                        window.location.href = link;
                        return;
                    }

                    // no need to ask for confirmation - just execute
                    if (action == 'view') {
                        $('#divModal_processing').modal('show');
                        // Load steps content into modal, send request to server via client-side
                        $('#steps_summary').load(link, function(response, status, xhr) {
                            $('#divModal_processing').modal('hide');
                            if (response != "error" && status != "error") {
                                // Update deploy id text in modal
                                $('#deploy_id_str').html(deploy_id);
                                // Show modal
                                $('#divModal_deploy').modal('show');
                            } else {
                                $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                                $('#divModal_msg').modal('show');
                            }
                        });
                        return;
                    }

                    // Extend button shows modal form
                    if (action == 'extend') {
                        // Reset form
                        $('#extend_form').trigger("reset");
                        $('#extend_form_error').html('');
                        // Fill inputs
                        $("input[name='deploy_id']").val(deploy_id);
                        var end_date_str = rowdata.end_date;
                        if (end_date_str) {
                            // Get and parse end date
                            var pat = /(\d{2})\/(\d{2})\/(\d{4})/;
                            var new_date = new Date(end_date_str.replace(pat, '$3-$2-$1'));
                            if (new_date) {
                                // Suggest a month from end date
                                new_date.setMonth(new_date.getMonth() + 1);
                                $("#id_to_date").datepicker('option', 'minDate', new_date);
                                $("#id_to_date").datepicker('setDate', new_date);
                            }
                        }
                        $('#deploy_label').html(deploy_id);
                        // Show modal form
                        $('#divModal_extend').modal('show');
                        return;
                    }

                    // Is the deploy already opened?
                    var open_deploy_id = {{ request.session.deploy_id.0|default:"-1" }};
                    if (action == 'open' && deploy_id == open_deploy_id) {
                        $('#divModal_processing').modal('show');

                        // Yes - No need to ask for confirmation, just redirect to deploy's last step
                        if (last_step == 7) {
                            window.location.href = '/{{ app }}/step' + (last_step) + '/';
                            return;
                        } else {
                            window.location.href = '/{{ app }}/step' + (last_step + 1) + '/';
                            return;
                        }
                    } else {
                        // All other actions require a confirmation
                        $('#cfm_tit').html(setmessage(action)[0]);
                        $('#cfm_str').html(setmessage(action)[1]);      // Set message according to action
                        $('#divModal_confirm').modal('show');           // Show Confirm Modal
                    }
                });
            });
        }

        function datesInfo(data) {
            // Return html dates to row
            var html_txt = '<b>{% trans "Criado a" %}</b> ' + data.creation_datetime;
            if (data.begin_date) html_txt += '<br/><b>{% trans "Início" %}</b> ' + data.begin_date;
            if (data.end_date) html_txt += '<br/><b>{% trans "Fim" %}</b> ' + data.end_date;
            if (data.last_run_date) html_txt += '<br/><b>{% trans "Última corrida" %}</b> ' + data.last_run_date;
            return html_txt;
        }

        // On Document Ready
        $(function(){
            {% if rate %}
            $('#divModal_rate').modal();
            {% endif %}

            // JQuery Table
            deploy_table = $('#deploy_table').DataTable({
                "searching": false,
                "info": false,
                "paging": false,
                "autoWidth": false,
                "ordering": true,
                "order": [[0,'desc']],
                "processing": true,
                "serverSide": false,
                "ajax": "{% url 'front:get_deploys' %}",
                "columns": [
                    { "data": "pk_code", "visible": false },
                    { "data": "pk", "title": "ID", "className": "pk", "orderData": 0 },
                    { "data": "state_code", "visible": false },
                    { "data": "begin_date", "visible": false },
                    { "data": "model", "title": '{% trans "Modelo" %}', "orderable": true, "className": "model" },
                    { "data": "name", "title": '{% trans "Nome" %}', "orderable": true, "className": "name" },
                    { "data": null, "title": '{% trans "Datas" %}', "orderData": 3, "className": "dates" , "render": function (data, type, row) {
                        return datesInfo(data);
                    }},
                    { "data": "state", "title": '{% trans "Estado" %}', "orderData": 2, "className": "state" },
                    { "data": "actions", "orderable": false, "className": "actions"},
                ],
                "drawCallback": function (settings) {
                    // After drawn set row actions
                    setactions();
                },
                "createdRow": function (row, data, index) {
                    if (data.description) {
                        // Add a details row to rows with description
                        var td = $('td', row).eq(0);
                        try {
                            var tr = td.closest('tr');
                            var nRow = this.api().row(tr);
                            var elem = data.description;
                            nRow.child(elem, 'details').show();
                        } catch (err) {
                            console.log(err);
                        }
                    }
                },
                "language": {
                    "emptyTable":       "{% trans 'Sem registos' %}",
                    "search":           "{% trans 'Pesquisar' %}",
                    "lengthMenu":       "_MENU_ {% trans 'registos' %}",
                    "paginate":
                    {
                        "previous": "<",
                        "next": ">",
                        "first": "<<",
                        "last": ">>"
                    }
                }
            });

            // Set action for confirmation button
            $('#exec_btn').click(function(e){
                var url_items = link.split('/');
                var action = url_items[2];
                var deploy_id = url_items[url_items.length-2];

                // Add some animation
                var btn = $(this);
                var btnlbl = btn.html().replace('<span class="glyphicon glyphicon-repeat spin"></span> ', '');
                btn.html('<span class="glyphicon glyphicon-repeat spin"></span> ' + btnlbl);

                // Disable buttons to prevent multiple calls
                btn.attr('disabled', '');
                btn.prev().attr('disabled', '');

                if (action == 'new') {
                    // Validate server-side if user can create new deploy
                    //newdeploy("{% url 'front:new_deploy' %}", "/{{ app }}/step1/restart/");
                    window.location.href = "{% url 'wizard:step1_restart' %}";
                    return;
                }

                if (action == 'open') {
                    // Open a different Deploy
                    window.location.href = link;
                    return;
                }

                // Send request to server via client-side
                $.ajax({
                    type: 'GET',
                    url: link,
                    success: function(data) {
                        // Reset form
                        btn.html(btnlbl);
                        btn.removeAttr('disabled');
                        btn.prev().removeAttr('disabled');

                        // Close confirm modal
                        $('#divModal_confirm').modal('hide');

                        // If success from server reload table
                        if (data["success"]) {
                            deploy_table.ajax.reload();
                        }

                        $('#msg_str').html(data["msg"]);
                        $('#divModal_msg').modal('show');
                    },
                    error: function(e, x, r) {
                        // Reset form
                        btn.html(btnlbl);
                        btn.removeAttr('disabled');
                        btn.prev().removeAttr('disabled');

                        // Close confirm modal
                        $('#divModal_confirm').modal('hide');

                        console.log(r + ' - ' + e);
                        $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                        $('#divModal_msg').modal('show');
                    }
                });
            });

            // Link JQuery Calendar to extend period form field
            $("#id_to_date").datepicker({
                dateFormat: '{% trans "dd/mm/yy" %}',
                dayNamesMin: [ '{% trans "Dom" %}', '{% trans "Seg" %}', '{% trans "Ter" %}', '{% trans "Qua" %}', '{% trans "Qui" %}',
                '{% trans "Sex" %}', '{% trans "Sab" %}' ],
                monthNames: ['{% trans "Janeiro" %}', '{% trans "Fevereiro" %}', '{% trans "Março" %}', '{% trans "Abril" %}', '{% trans "Maio" %}',
                '{% trans "Junho" %}', '{% trans "Julho" %}', '{% trans "Agosto" %}', '{% trans "Setembro" %}', '{% trans "Outubro" %}',
                '{% trans "Novembro" %}', '{% trans "Dezembro" %}'],
            });

            // Highlight "prev row" from details row on hover (no previous selector with css); "next row" highlight has css selector
            $(document).on("mouseenter", "tr", function() {
                var prevrow = $(this).prev();
                if($(this).hasClass("details")) $(prevrow).css("background", "#f5f5f5");
            });
            $(document).on("mouseleave", "tr", function() {
                var prevrow = $(this).prev();
                if($(this).hasClass("details")) $(prevrow).css("background", "");
            });

            /* NOT IN USE
            // Tips Settings
            var intro = introJs();
            intro.setOptions({
                "nextLabel": " » ",
                "prevLabel": " « ",
                "skipLabel": " {% trans 'Fechar' %} ",
                "doneLabel": " {% trans 'Terminado' %} ",
                "disableInteraction": true,
                "tooltipPosition": "top"
            });
            */
        });
    </script>

    <!-- Load JQuery dataTables -->
    <script src="{% static 'vendor/jquery-dataTables/jquery.dataTables.min.js' %}"></script>

{% endblock content %}